Index: palm/trunk/SOURCE/flow_statistics.f90
===================================================================
--- palm/trunk/SOURCE/flow_statistics.f90	(revision 4901)
+++ palm/trunk/SOURCE/flow_statistics.f90	(revision 1)
@@ -525,407 +325,135 @@
 !
 !--    Passive scalar
-       IF ( passive_scalar )  hom(:,1,115,sr) = sums(:,115) / ngp_2dh_s_inner(:,sr)  ! s
-
-!
-!--    Horizontally averaged profiles of the remaining prognostic variables, variances, the total
-!--    and the perturbation energy (single values in last column of sums_l) and some diagnostic
-!--    quantities.
-!--    NOTE: for simplicity, nzb_s_inner is used below, although strictly speaking the following
-!--    ----  k-loop would have to be split up and rearranged according to the staggered grid.
-!--          However, this implies no error since staggered velocity components are zero at the
-!--          walls and inside buildings.
+       IF ( passive_scalar )  hom(:,1,41,sr) = sums(:,41) / ngp_2dh_outer(:,sr)
+
+!
+!--    Horizontally averaged profiles of the remaining prognostic variables,
+!--    variances, the total and the perturbation energy (single values in last
+!--    column of sums_l) and some diagnostic quantities.
+!--    NOTE: for simplicity, nzb_s_outer is used below, although strictly 
+!--    ----  speaking the following k-loop would have to be split up and 
+!--          rearranged according to the staggered grid.
        tn = 0
-       !$OMP PARALLEL PRIVATE( i, j, k, pts, sums_ll,                          &
-       !$OMP                   sums_l_etot, tn, ust, ust2, u2, vst, vst2, v2,  &
-       !$OMP                   w2, flag, m, ki, l )
-       !$ tn = omp_get_thread_num()
+#if defined( __lcmuk )
+       !$OMP PARALLEL PRIVATE( i, j, k, pts, sums_ll, sums_l_eper, sums_l_etot, &
+       !$OMP                    tn, ust, ust2, u2, vst, vst2, v2, w2 )
+       tn = omp_get_thread_num()
+#else
+       !$OMP PARALLEL PRIVATE( i, j, k, pts, sums_ll, sums_l_eper, sums_l_etot, tn, ust, ust2, u2, vst, vst2, v2, w2 )
+!$     tn = omp_get_thread_num()
+#endif
        !$OMP DO
-       !$ACC PARALLEL LOOP COLLAPSE(2) PRIVATE(i, j, k, m) &
-       !$ACC PRIVATE(sums_l_etot, flag, du_dx, du_dy, du_dz) &
-       !$ACC PRIVATE(dv_dx, dv_dy, dv_dz, dw_dx, dw_dy, dw_dz) &
-       !$ACC PRIVATE(s11, s21, s31, s12, s22, s32, s13, s23, s33) &
-       !$ACC PRIVATE(dissipation, eta) &
-       !$ACC PRESENT(wall_flags_total_0, rmask, momentumflux_output_conversion) &
-       !$ACC PRESENT(hom(:,1,1:2,sr), hom(:,1,4,sr)) &
-       !$ACC PRESENT(e, u, v, w, km, kh, p, pt) &
-       !$ACC PRESENT(ddx, ddy, ddzu, ddzw) &
-       !$ACC PRESENT(surf_def_h(0), surf_lsm_h(0), surf_usm_h(0)) &
-       !$ACC PRESENT(sums_l)
        DO  i = nxl, nxr
           DO  j =  nys, nyn
-             sums_l_etot = 0.0_wp
-             DO  k = nzb, nzt+1
-                flag = MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_total_0(k,j,i), 22 ) )
-!
-!--             Prognostic and diagnostic variables
-                !$ACC ATOMIC
-                sums_l(k,3,tn)  = sums_l(k,3,tn)  + w(k,j,i)  * rmask(j,i,sr) * flag
-                !$ACC ATOMIC
-                sums_l(k,8,tn)  = sums_l(k,8,tn)  + e(k,j,i)  * rmask(j,i,sr) * flag
-                !$ACC ATOMIC
-                sums_l(k,9,tn)  = sums_l(k,9,tn)  + km(k,j,i) * rmask(j,i,sr) * flag
-                !$ACC ATOMIC
-                sums_l(k,10,tn) = sums_l(k,10,tn) + kh(k,j,i) * rmask(j,i,sr) * flag
-                !$ACC ATOMIC
-                sums_l(k,40,tn) = sums_l(k,40,tn) + ( p(k,j,i)                                     &
-                                         / momentumflux_output_conversion(k) ) * flag
-
-                !$ACC ATOMIC
-                sums_l(k,33,tn) = sums_l(k,33,tn) + &
-                                  ( pt(k,j,i)-hom(k,1,4,sr) )**2 * rmask(j,i,sr) * flag
-#ifndef _OPENACC
-                IF ( humidity )  THEN
-                   sums_l(k,70,tn) = sums_l(k,70,tn) +                                             &
-                                     ( q(k,j,i)-hom(k,1,41,sr) )**2 * rmask(j,i,sr) * flag
-                ENDIF
-                IF ( passive_scalar )  THEN
-                   sums_l(k,116,tn) = sums_l(k,116,tn) +                                           &
-                                      ( s(k,j,i)-hom(k,1,115,sr) )**2 * rmask(j,i,sr) * flag
-                ENDIF
-#endif
-!
-!--             Higher moments
-!--             (Computation of the skewness of w further below)
-                !$ACC ATOMIC
-                sums_l(k,38,tn) = sums_l(k,38,tn) + w(k,j,i)**3 * rmask(j,i,sr) * flag
-
-                sums_l_etot  = sums_l_etot + 0.5_wp * ( u(k,j,i)**2 + v(k,j,i)**2 + w(k,j,i)**2 )  &
-                                             * rmask(j,i,sr) * flag
-
-!
-!--             Computation of the Kolmogorov length scale. Calculation is based on gradients of the
-!--             deviations from the horizontal mean.
-!--             Kolmogorov scale at the boundaries (k=0/z=0m and k=nzt+1) is set to zero.
-                IF ( kolmogorov_length_scale .AND. k /= nzb .AND. k /= nzt+1) THEN
-                   flag = MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_total_0(k,j,i), 22 ) )
-
-!
-!--                Calculate components of the fluctuating rate-of-strain tensor
-!--                (0.5*(del u'_i/del x_j + del u'_j/del x_i)) defined in the center of each grid
-!--                box.
-                   du_dx = ( ( u(k,j,i+1) - hom(k,1,1,sr) ) -                                      &
-                             ( u(k,j,i) - hom(k,1,1,sr) ) ) * ddx
-                   du_dy = 0.25_wp * ddy *                                                         &
-                           ( ( u(k,j+1,i) - hom(k,1,1,sr) ) -                                      &
-                             ( u(k,j-1,i) - hom(k,1,1,sr) ) +                                      &
-                             ( u(k,j+1,i+1) - hom(k,1,1,sr) ) -                                    &
-                             ( u(k,j-1,i+1) - hom(k,1,1,sr) ) )
-                   du_dz = 0.25_wp * ( ( ( u(k+1,j,i) - hom(k+1,1,1,sr) ) -                        &
-                                         ( u(k,j,i) - hom(k,1,1,sr) ) ) *                          &
-                                       ddzu(k+1) +                                                 &
-                                       ( ( u(k,j,i) - hom(k,1,1,sr) ) -                            &
-                                         ( u(k-1,j,i) - hom(k-1,1,1,sr) ) ) *                      &
-                                       ddzu(k) +                                                   &
-                                       ( ( u(k+1,j,i+1) - hom(k+1,1,1,sr) ) -                      &
-                                         ( u(k,j,i+1) - hom(k,1,1,sr) ) ) *                        &
-                                       ddzu(k+1) +                                                 &
-                                       ( ( u(k,j,i+1) - hom(k,1,1,sr) ) -                          &
-                                         ( u(k-1,j,i+1) - hom(k-1,1,1,sr) ) ) *                    &
-                                       ddzu(k) )
-
-                   dv_dx = 0.25_wp * ddx *                                                         &
-                           ( ( v(k,j,i+1) - hom(k,1,2,sr) ) -                                      &
-                             ( v(k,j,i-1) - hom(k,1,2,sr) ) +                                      &
-                             ( v(k,j+1,i+1) - hom(k,1,2,sr) ) -                                    &
-                             ( v(k,j+1,i-1) - hom(k,1,2,sr) ) )
-                   dv_dy = ( ( v(k,j+1,i) - hom(k,1,2,sr) ) - ( v(k,j,i) - hom(k,1,2,sr) ) ) * ddy
-                   dv_dz = 0.25_wp * ( ( ( v(k+1,j,i) - hom(k+1,1,2,sr) ) -                        &
-                                         ( v(k,j,i) - hom(k,1,2,sr) ) ) *                          &
-                                       ddzu(k+1) +                                                 &
-                                       ( ( v(k,j,i) - hom(k,1,2,sr) ) -                            &
-                                         ( v(k-1,j,i) - hom(k-1,1,2,sr) ) ) *                      &
-                                       ddzu(k) +                                                   &
-                                       ( ( v(k+1,j+1,i) - hom(k+1,1,2,sr) ) -                      &
-                                         ( v(k,j+1,i) - hom(k,1,2,sr) ) ) *                        &
-                                       ddzu(k+1) +                                                 &
-                                       ( ( v(k,j+1,i) - hom(k,1,2,sr) ) -                          &
-                                         ( v(k-1,j+1,i) - hom(k-1,1,2,sr) ) ) *                    &
-                                       ddzu(k) )
-
-                   dw_dx = 0.25_wp * ddx * ( w(k,j,i+1) - w(k,j,i-1) + w(k-1,j,i+1) - w(k-1,j,i-1) )
-                   dw_dy = 0.25_wp * ddy * ( w(k,j+1,i) - w(k,j-1,i) + w(k-1,j+1,i) - w(k-1,j-1,i) )
-                   dw_dz = ( w(k,j,i) - w(k-1,j,i) ) * ddzw(k)
-
-                   s11 = 0.5_wp * ( du_dx + du_dx )
-                   s21 = 0.5_wp * ( dv_dx + du_dy )
-                   s31 = 0.5_wp * ( dw_dx + du_dz )
-
-                   s12 = s21
-                   s22 = 0.5 * ( dv_dy + dv_dy )
-                   s32 = 0.5 * ( dw_dy + dv_dz )
-
-                   s13 = s31
-                   s23 = s32
-                   s33 = 0.5_wp * ( dw_dz + dw_dz )
-
-!--                Calculate 3D instantaneous energy dissipation rate following Pope (2000):
-!--                Turbulent flows, p.259. It is defined in the center of each grid volume.
-                   dissipation = 2.0_wp * km(k,j,i) *                                              &
-                                ( s11*s11 + s21*s21 + s31*s31 +                                    &
-                                  s12*s12 + s22*s22 + s32*s32 +                                    &
-                                  s13*s13 + s23*s23 + s33*s33 )
-                   eta         = ( km(k,j,i)**3.0_wp / ( dissipation+1.0E-12 ) )**(1.0_wp/4.0_wp)
-
-                   !$ACC ATOMIC
-                   sums_l(k,121,tn) = sums_l(k,121,tn) + eta * rmask(j,i,sr) * flag
-
-
-                ENDIF !Kolmogorov length scale
-
-             ENDDO !k-loop
-!
-!--          Total and perturbation energy for the total domain (being collected in the last column
-!--          of sums_l). Summation of these quantities is seperated from the previous loop in order
-!--          to allow vectorization of that loop.
-             !$ACC ATOMIC
-             sums_l(nzb+4,pr_palm,tn) = sums_l(nzb+4,pr_palm,tn) + sums_l_etot
-!
-!--          2D-arrays (being collected in the last column of sums_l)
-             IF ( surf_def_h(0)%end_index(j,i) >= surf_def_h(0)%start_index(j,i) )  THEN
-                m = surf_def_h(0)%start_index(j,i)
-                !$ACC ATOMIC
-                sums_l(nzb,pr_palm,tn)   = sums_l(nzb,pr_palm,tn) +                                &
-                                           surf_def_h(0)%us(m)   * rmask(j,i,sr)
-                !$ACC ATOMIC
-                sums_l(nzb+1,pr_palm,tn) = sums_l(nzb+1,pr_palm,tn) +                              &
-                                           surf_def_h(0)%usws(m) * rmask(j,i,sr)
-                !$ACC ATOMIC
-                sums_l(nzb+2,pr_palm,tn) = sums_l(nzb+2,pr_palm,tn) +                              &
-                                           surf_def_h(0)%vsws(m) * rmask(j,i,sr)
-                !$ACC ATOMIC
-                sums_l(nzb+3,pr_palm,tn) = sums_l(nzb+3,pr_palm,tn) +                              &
-                                           surf_def_h(0)%ts(m)   * rmask(j,i,sr)
-#ifndef _OPENACC
-                IF ( humidity )  THEN
-                   sums_l(nzb+12,pr_palm,tn) = sums_l(nzb+12,pr_palm,tn) +                         &
-                                               surf_def_h(0)%qs(m)   * rmask(j,i,sr)
-                ENDIF
-                IF ( passive_scalar )  THEN
-                   sums_l(nzb+13,pr_palm,tn) = sums_l(nzb+13,pr_palm,tn) +                         &
-                                               surf_def_h(0)%ss(m)   * rmask(j,i,sr)
-                ENDIF
-#endif
-!
-!--             Summation of surface temperature.
-                !$ACC ATOMIC
-                sums_l(nzb+14,pr_palm,tn) = sums_l(nzb+14,pr_palm,tn)   +                          &
-                                            surf_def_h(0)%pt_surface(m) * rmask(j,i,sr)
-             ENDIF
-             IF ( surf_lsm_h(0)%end_index(j,i) >= surf_lsm_h(0)%start_index(j,i) )  THEN
-                m = surf_lsm_h(0)%start_index(j,i)
-                !$ACC ATOMIC
-                sums_l(nzb,pr_palm,tn)   = sums_l(nzb,pr_palm,tn) +                                &
-                                           surf_lsm_h(0)%us(m)   * rmask(j,i,sr)
-                !$ACC ATOMIC
-                sums_l(nzb+1,pr_palm,tn) = sums_l(nzb+1,pr_palm,tn) +                              &
-                                           surf_lsm_h(0)%usws(m) * rmask(j,i,sr)
-                !$ACC ATOMIC
-                sums_l(nzb+2,pr_palm,tn) = sums_l(nzb+2,pr_palm,tn) +                              &
-                                           surf_lsm_h(0)%vsws(m) * rmask(j,i,sr)
-                !$ACC ATOMIC
-                sums_l(nzb+3,pr_palm,tn) = sums_l(nzb+3,pr_palm,tn) +                              &
-                                           surf_lsm_h(0)%ts(m)   * rmask(j,i,sr)
-#ifndef _OPENACC
-                IF ( humidity )  THEN
-                   sums_l(nzb+12,pr_palm,tn) = sums_l(nzb+12,pr_palm,tn) +                         &
-                                               surf_lsm_h(0)%qs(m)   * rmask(j,i,sr)
-                ENDIF
-                IF ( passive_scalar )  THEN
-                   sums_l(nzb+13,pr_palm,tn) = sums_l(nzb+13,pr_palm,tn) +                         &
-                                               surf_lsm_h(0)%ss(m)   * rmask(j,i,sr)
-                ENDIF
-#endif
-!
-!--             Summation of surface temperature.
-                !$ACC ATOMIC
-                sums_l(nzb+14,pr_palm,tn) = sums_l(nzb+14,pr_palm,tn) +                            &
-                                            surf_lsm_h(0)%pt_surface(m) * rmask(j,i,sr)
-             ENDIF
-             IF ( surf_usm_h(0)%end_index(j,i) >= surf_usm_h(0)%start_index(j,i) )  THEN
-                m = surf_usm_h(0)%start_index(j,i)
-                !$ACC ATOMIC
-                sums_l(nzb,pr_palm,tn)   = sums_l(nzb,pr_palm,tn) +                                &
-                                           surf_usm_h(0)%us(m)   * rmask(j,i,sr)
-                !$ACC ATOMIC
-                sums_l(nzb+1,pr_palm,tn) = sums_l(nzb+1,pr_palm,tn) +                              &
-                                           surf_usm_h(0)%usws(m) * rmask(j,i,sr)
-                !$ACC ATOMIC
-                sums_l(nzb+2,pr_palm,tn) = sums_l(nzb+2,pr_palm,tn) +                              &
-                                           surf_usm_h(0)%vsws(m) * rmask(j,i,sr)
-                !$ACC ATOMIC
-                sums_l(nzb+3,pr_palm,tn) = sums_l(nzb+3,pr_palm,tn) +                              &
-                                           surf_usm_h(0)%ts(m)   * rmask(j,i,sr)
-#ifndef _OPENACC
-                IF ( humidity )  THEN
-                   sums_l(nzb+12,pr_palm,tn) = sums_l(nzb+12,pr_palm,tn) +                         &
-                                               surf_usm_h(0)%qs(m)   * rmask(j,i,sr)
-                ENDIF
-                IF ( passive_scalar )  THEN
-                   sums_l(nzb+13,pr_palm,tn) = sums_l(nzb+13,pr_palm,tn) +                         &
-                                               surf_usm_h(0)%ss(m) * rmask(j,i,sr)
-                ENDIF
-#endif
-!
-!--             Summation of surface temperature.
-                !$ACC ATOMIC
-                sums_l(nzb+14,pr_palm,tn) = sums_l(nzb+14,pr_palm,tn) +                            &
-                                            surf_usm_h(0)%pt_surface(m)  * rmask(j,i,sr)
-             ENDIF
-          ENDDO !j-loop
-       ENDDO !i-loop
-       !$ACC UPDATE &
-       !$ACC HOST(sums_l(:,3,tn), sums_l(:,8,tn), sums_l(:,9,tn)) &
-       !$ACC HOST(sums_l(:,10,tn), sums_l(:,40,tn), sums_l(:,33,tn)) &
-       !$ACC HOST(sums_l(:,38,tn), sums_l(:,121,tn)) &
-       !$ACC HOST(sums_l(nzb:nzb+4,pr_palm,tn), sums_l(nzb+14:nzb+14,pr_palm,tn))
-
-!
-!--    Computation of statistics when ws-scheme is not used. Else these
-!--    quantities are evaluated in the advection routines.
-       IF ( .NOT. ws_scheme_mom .OR. sr /= 0 .OR. simulated_time == 0.0_wp )  THEN
-          !$OMP DO
-          DO  i = nxl, nxr
-             DO  j =  nys, nyn
-                DO  k = nzb, nzt+1
-                   flag = MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_total_0(k,j,i), 22 ) )
-
-                   u2   = u(k,j,i)**2
-                   v2   = v(k,j,i)**2
-                   w2   = w(k,j,i)**2
-                   ust2 = ( u(k,j,i) - hom(k,1,1,sr) )**2
-                   vst2 = ( v(k,j,i) - hom(k,1,2,sr) )**2
-
-                   sums_l(k,30,tn) = sums_l(k,30,tn) + ust2 * rmask(j,i,sr) * flag
-                   sums_l(k,31,tn) = sums_l(k,31,tn) + vst2 * rmask(j,i,sr) * flag
-                   sums_l(k,32,tn) = sums_l(k,32,tn) + w2   * rmask(j,i,sr) * flag
-!
-!--                Perturbation energy
-                   sums_l(k,34,tn) = sums_l(k,34,tn) +                                             &
-                                     0.5_wp * ( ust2 + vst2 + w2 ) * rmask(j,i,sr) * flag
-                ENDDO
-             ENDDO
-          ENDDO
-       ENDIF
-!
-!--    Computaion of domain-averaged perturbation energy. Please note, to prevent that perturbation
-!--    energy is larger (even if only slightly) than the total kinetic energy, calculation is based
-!--    on deviations from the horizontal mean, instead of spatial descretization of the advection
-!--    term.
-       !$OMP DO
-       !$ACC PARALLEL LOOP COLLAPSE(3) PRIVATE(i, j, k, flag, w2, ust2, vst2) &
-       !$ACC PRESENT(wall_flags_total_0, u, v, w, rmask, hom(:,1,1:2,sr)) &
-       !$ACC PRESENT(sums_l)
-       DO  i = nxl, nxr
-          DO  j =  nys, nyn
-             DO  k = nzb, nzt+1
-                flag = MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_total_0(k,j,i), 22 ) )
-
+             sums_l_etot = 0.0
+             sums_l_eper = 0.0
+             DO  k = nzb_s_outer(j,i), nzt+1
+                u2   = u(k,j,i)**2
+                v2   = v(k,j,i)**2
                 w2   = w(k,j,i)**2
                 ust2 = ( u(k,j,i) - hom(k,1,1,sr) )**2
                 vst2 = ( v(k,j,i) - hom(k,1,2,sr) )**2
-                w2   = w(k,j,i)**2
-
-                !$ACC ATOMIC
-                sums_l(nzb+5,pr_palm,tn) = sums_l(nzb+5,pr_palm,tn)                                &
-                                           + 0.5_wp * ( ust2 + vst2 + w2 ) * rmask(j,i,sr) * flag
-
-             ENDDO
+!
+!--             Prognostic and diagnostic variables
+                sums_l(k,3,tn)  = sums_l(k,3,tn)  + w(k,j,i)  * rmask(j,i,sr)
+                sums_l(k,8,tn)  = sums_l(k,8,tn)  + e(k,j,i)  * rmask(j,i,sr)
+                sums_l(k,9,tn)  = sums_l(k,9,tn)  + km(k,j,i) * rmask(j,i,sr)
+                sums_l(k,10,tn) = sums_l(k,10,tn) + kh(k,j,i) * rmask(j,i,sr)
+                sums_l(k,40,tn) = sums_l(k,40,tn) + p(k,j,i)
+
+!
+!--             Variances
+                sums_l(k,30,tn) = sums_l(k,30,tn) + ust2 * rmask(j,i,sr)
+                sums_l(k,31,tn) = sums_l(k,31,tn) + vst2 * rmask(j,i,sr)
+                sums_l(k,32,tn) = sums_l(k,32,tn) + w2   * rmask(j,i,sr)
+                sums_l(k,33,tn) = sums_l(k,33,tn) + &
+                                  ( pt(k,j,i)-hom(k,1,4,sr) )**2 * rmask(j,i,sr)
+!
+!--             Higher moments
+!--             (Computation of the skewness of w further below)
+                sums_l(k,38,tn) = sums_l(k,38,tn) + w(k,j,i) * w2 * &
+                                                    rmask(j,i,sr)
+!
+!--             Perturbation energy
+                sums_l(k,34,tn) = sums_l(k,34,tn) + 0.5 * ( ust2 + vst2 + w2 ) &
+                                                    * rmask(j,i,sr)
+                sums_l_etot  = sums_l_etot + &
+                                        0.5 * ( u2 + v2 + w2 ) * rmask(j,i,sr)
+                sums_l_eper  = sums_l_eper + &
+                                        0.5 * ( ust2+vst2+w2 ) * rmask(j,i,sr)
+             ENDDO
+!
+!--          Total and perturbation energy for the total domain (being
+!--          collected in the last column of sums_l). Summation of these
+!--          quantities is seperated from the previous loop in order to
+!--          allow vectorization of that loop.
+             sums_l(nzb+4,var_sum,tn) = sums_l(nzb+4,var_sum,tn) + sums_l_etot
+             sums_l(nzb+5,var_sum,tn) = sums_l(nzb+5,var_sum,tn) + sums_l_eper
+!
+!--          2D-arrays (being collected in the last column of sums_l)
+             sums_l(nzb,var_sum,tn)   = sums_l(nzb,var_sum,tn) +   &
+                                        us(j,i)   * rmask(j,i,sr)
+             sums_l(nzb+1,var_sum,tn) = sums_l(nzb+1,var_sum,tn) + &
+                                        usws(j,i) * rmask(j,i,sr)
+             sums_l(nzb+2,var_sum,tn) = sums_l(nzb+2,var_sum,tn) + &
+                                        vsws(j,i) * rmask(j,i,sr)
+             sums_l(nzb+3,var_sum,tn) = sums_l(nzb+3,var_sum,tn) + &
+                                        ts(j,i)   * rmask(j,i,sr)
           ENDDO
        ENDDO
-       !$ACC UPDATE HOST(sums_l(nzb+5:nzb+5,pr_palm,tn))
 
 !
 !--    Horizontally averaged profiles of the vertical fluxes
        !$OMP DO
-       !$ACC PARALLEL LOOP COLLAPSE(2) PRIVATE(i, j, k, l, m) &
-       !$ACC PRIVATE(ki, flag, ust, vst, pts) &
-       !$ACC PRESENT(kh, km, u, v, w, pt) &
-       !$ACC PRESENT(wall_flags_total_0, rmask, ddzu, rho_air_zw, hom(:,1,1:4,sr)) &
-       !$ACC PRESENT(heatflux_output_conversion, momentumflux_output_conversion) &
-       !$ACC PRESENT(surf_def_h(0:2), surf_lsm_h(0:1), surf_usm_h(0:1)) &
-       !$ACC PRESENT(sums_l)
        DO  i = nxl, nxr
           DO  j = nys, nyn
 !
-!--          Subgridscale fluxes (without Prandtl layer from k=nzb, oterwise from k=nzb+1)
-!--          NOTE: for simplicity, nzb_diff_s_inner is used below, although strictly speaking the
-!--          ----  following k-loop would have to be split up according to the staggered grid.
-!--                However, this implies no error since staggered velocity components are zero at
-!--                the walls and inside buildings.
-!--          Flag 23 is used to mask surface fluxes as well as model-top fluxes, which are added
-!--          further below.
-             DO  k = nzb, nzt
-                flag = MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_total_0(k,j,i), 23 ) ) *           &
-                       MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_total_0(k,j,i), 9  ) )
+!--          Subgridscale fluxes (without Prandtl layer from k=nzb, 
+!--          oterwise from k=nzb+1)
+!--          NOTE: for simplicity, nzb_diff_s_outer is used below, although
+!--          ----  strictly speaking the following k-loop would have to be
+!--                split up according to the staggered grid.
+             DO  k = nzb_diff_s_outer(j,i)-1, nzt
 !
 !--             Momentum flux w"u"
-                !$ACC ATOMIC
-                sums_l(k,12,tn) = sums_l(k,12,tn) - 0.25_wp * (                                    &
-                                  km(k,j,i) + km(k+1,j,i) + km(k,j,i-1) + km(k+1,j,i-1)            &
-                                                              ) * (                                &
-                                      ( u(k+1,j,i) - u(k,j,i)   ) * ddzu(k+1)                      &
-                                    + ( w(k,j,i)   - w(k,j,i-1) ) * ddx                            &
-                                                                  ) * rmask(j,i,sr)                &
-                                            * rho_air_zw(k)                                        &
-                                            * momentumflux_output_conversion(k)                    &
-                                            * flag
+                sums_l(k,12,tn) = sums_l(k,12,tn) - 0.25 * (                   &
+                               km(k,j,i)+km(k+1,j,i)+km(k,j,i-1)+km(k+1,j,i-1) &
+                                                           ) * (               &
+                                   ( u(k+1,j,i) - u(k,j,i)   ) * ddzu(k+1)     &
+                                 + ( w(k,j,i)   - w(k,j,i-1) ) * ddx           &
+                                                               ) * rmask(j,i,sr)
 !
 !--             Momentum flux w"v"
-                !$ACC ATOMIC
-                sums_l(k,14,tn) = sums_l(k,14,tn) - 0.25_wp * (                                    &
-                                  km(k,j,i) + km(k+1,j,i) + km(k,j-1,i) + km(k+1,j-1,i)            &
-                                                              ) * (                                &
-                                      ( v(k+1,j,i) - v(k,j,i)   ) * ddzu(k+1)                      &
-                                    + ( w(k,j,i)   - w(k,j-1,i) ) * ddy                            &
-                                                                  ) * rmask(j,i,sr)                &
-                                            * rho_air_zw(k)                                        &
-                                            * momentumflux_output_conversion(k)                    &
-                                            * flag
+                sums_l(k,14,tn) = sums_l(k,14,tn) - 0.25 * (                   &
+                               km(k,j,i)+km(k+1,j,i)+km(k,j-1,i)+km(k+1,j-1,i) &
+                                                           ) * (               &
+                                   ( v(k+1,j,i) - v(k,j,i)   ) * ddzu(k+1)     &
+                                 + ( w(k,j,i)   - w(k,j-1,i) ) * ddy           &
+                                                               ) * rmask(j,i,sr)
 !
 !--             Heat flux w"pt"
-                !$ACC ATOMIC
-                sums_l(k,16,tn) = sums_l(k,16,tn)                                                  &
-                                         - 0.5_wp * ( kh(k,j,i) + kh(k+1,j,i) )                    &
-                                               * ( pt(k+1,j,i) - pt(k,j,i) )                       &
-                                               * rho_air_zw(k)                                     &
-                                               * heatflux_output_conversion(k)                     &
-                                               * ddzu(k+1) * rmask(j,i,sr)                         &
-                                               * flag
-
-!
-!--             Salinity flux w"sa"
-#ifndef _OPENACC
-                IF ( ocean_mode )  THEN
-                   sums_l(k,65,tn) = sums_l(k,65,tn)                                               &
-                                         - 0.5_wp * ( kh(k,j,i) + kh(k+1,j,i) )                    &
-                                               * ( sa(k+1,j,i) - sa(k,j,i) )                       &
-                                               * ddzu(k+1) * rmask(j,i,sr)                         &
-                                               * flag
-                ENDIF
+                sums_l(k,16,tn) = sums_l(k,16,tn)                              &
+                                         - 0.5 * ( kh(k,j,i) + kh(k+1,j,i) )   &
+                                               * ( pt(k+1,j,i) - pt(k,j,i) )   &
+                                               * ddzu(k+1) * rmask(j,i,sr)
+
 
 !
 !--             Buoyancy flux, water flux (humidity flux) w"q"
-                IF ( humidity ) THEN
-                   sums_l(k,45,tn) = sums_l(k,45,tn)                                               &
-                                         - 0.5_wp * ( kh(k,j,i) + kh(k+1,j,i) )                    &
-                                               * ( vpt(k+1,j,i) - vpt(k,j,i) )                     &
-                                               * rho_air_zw(k)                                     &
-                                               * heatflux_output_conversion(k)                     &
-                                               * ddzu(k+1) * rmask(j,i,sr) * flag
-                   sums_l(k,48,tn) = sums_l(k,48,tn)                                               &
-                                         - 0.5_wp * ( kh(k,j,i) + kh(k+1,j,i) )                    &
-                                               * ( q(k+1,j,i) - q(k,j,i) )                         &
-                                               * rho_air_zw(k)                                     &
-                                               * waterflux_output_conversion(k)                    &
-                                               * ddzu(k+1) * rmask(j,i,sr) * flag
-
-                   IF ( bulk_cloud_model ) THEN
-                      sums_l(k,51,tn) = sums_l(k,51,tn)                                            &
-                                         - 0.5_wp * ( kh(k,j,i) + kh(k+1,j,i) )                    &
-                                               * ( ( q(k+1,j,i) - ql(k+1,j,i) )                    &
-                                                - ( q(k,j,i) - ql(k,j,i) ) )                       &
-                                               * rho_air_zw(k)                                     &
-                                               * waterflux_output_conversion(k)                    &
-                                               * ddzu(k+1) * rmask(j,i,sr) * flag
+                IF ( moisture ) THEN
+                   sums_l(k,45,tn) = sums_l(k,45,tn)                           &
+                                         - 0.5 * ( kh(k,j,i) + kh(k+1,j,i) )   &
+                                               * ( vpt(k+1,j,i) - vpt(k,j,i) ) &
+                                               * ddzu(k+1) * rmask(j,i,sr)
+                   sums_l(k,48,tn) = sums_l(k,48,tn)                           &
+                                         - 0.5 * ( kh(k,j,i) + kh(k+1,j,i) )   &
+                                               * ( q(k+1,j,i) - q(k,j,i) )     &
+                                               * ddzu(k+1) * rmask(j,i,sr)
+                   IF ( cloud_physics ) THEN
+                      sums_l(k,51,tn) = sums_l(k,51,tn)                        &
+                                         - 0.5 * ( kh(k,j,i) + kh(k+1,j,i) )   &
+                                               * ( ( q(k+1,j,i) - ql(k+1,j,i) )&
+                                                - ( q(k,j,i) - ql(k,j,i) ) )   &
+                                               * ddzu(k+1) * rmask(j,i,sr) 
                    ENDIF
                 ENDIF
